#define MAX_LINE_SIZE 1024
#define STR_MAX 1024
#define DISTNATION_LENGTH 100
#define POINT_MAX 4096 /*--  --*/
#define POLYGON_MAX 4096
#define PUBKEY_LENGTH 20
//|S͑߂
//H̒L̓ǂݍ
#define  DORO_ARC 0
#define  SANKAKU_PNT 1
#define  GYOUSEI_CITY_PGN 2
#define  GYOUSEI_TOWN_PGN 3
#define  GAIKU_PGN 4
#define  TATEMONO_PGN 5
#define  EKI_PNT 6
#define  TETUDOU_ARC 7
#define  ZYOUTI_PGN 8
#define  MIZU_PGN 9
//#define  MIZU_ARC 10
#define DATASOURCE_MAX 10

//arcH   *GetCSVItem(char *, char *);
typedef struct arcH{
      char FH[3];/*--FH--*/
      char zumei[30];/*--}--*/
      char filename[40];/*--t@C--*/
      int recordC;/*--R[h--*/
      int fieldC;/*--vf̑--*/
      int CoordFlag;/*--WntO--*/
      int Coordinate;/*--Wnԍ--*/
      int kubun;/*--l敪--*/
      double llx;/*----*/
      double lly;/*----*/
      double rux;/*--E--*/
      double ruy;/*--E--*/
      double lux;/*----*/   
      double luy;/*----*/
      double rlx;/*--E--*/
      double rly;/*--E--*/
}arch_P;/*--t@Cwb_[R[h̍\--*/

typedef struct arcIDPnt{
      char code[5];/*--}ރR[h--*/
	char  pubKey[PUBKEY_LENGTH];/*--ʏ--*/
      double pX;/*--W_X--*/
      double pY;/*--W_Y--*/
      struct arcIDPnt *next;/*-- ̃|C^[ --*/
   } pnt_P;/*--A[NIDR[h--*/

typedef struct arcIDRec{
      char code[5];/*--}ރR[h--*/
      int  lineTag;/*--^O--*/
	char  pubKey[PUBKEY_LENGTH];/*--ʏ--*/
      int  count;/*--YA[N\WR[h̐--*/
      double pX[POINT_MAX];/*--W_X--*/
      double pY[POINT_MAX];/*--W_Y--*/
      struct arcIDRec *next;/*-- ̃|C^[ --*/
   }arc_P;/*--A[NIDR[h--*/

typedef struct pgnIDRec{
	char code[10];/*--}ރR[h--*/
	char  pubKey[PUBKEY_LENGTH];/*--ʏ--*/
	int  count;/*--Y|S\A[Nw背R[h̐--*/
	double cX;/*--\_XW--*/
	double cY;/*--\_YW--*/
      double pX[POLYGON_MAX];/*--W_X--*/
	double pY[POLYGON_MAX];/*--W_Y--*/
	int maxPoints;
	struct pgnIDRec *next;/*-- ̃|C^[ --*/
   }pgn_P;/*--|SIDR[h--*/

typedef struct atrIDRec{
	char code[10];/*--}ރR[h--*/
	char  pubKey[PUBKEY_LENGTH];/*--ʏ--*/
	int count;//
	char  field1[STR_MAX];/*--ʏ--*/
	char  field2[STR_MAX];/*--ʏ--*/
	char  field3[STR_MAX];/*--ʏ--*/
	char  field4[STR_MAX];/*--ʏ--*/
	char  field5[STR_MAX];/*--ʏ--*/
	struct atrIDRec *next;/*-- ̃|C^[ --*/
}atr_P;


//sdf_ogr.c
int readDir(char *Path);

//ꂼ̃C[J߂̊֐
//܂Ƃ߂ǁAꂼȂ̂œH
int createRoadObject(char *Path);
int createSankakuObject(char *Path);
int createGyouseiObject(char *Path);
int createGaikuObject(char *Path);
int createTatemonoObject(char *Path);
int createWaterObject(char *Path);
int createOthersObject(char *Path);

int removeTabFile(const char *);
void replaceSpace(char *Path);
static void Usage( void );

//sdf_read.c
atr_P *readAtrFiletoObject(const char *);
arc_P *readArcFiletoObject(const char *filename);
pgn_P *readPgnFiletoObject(const char *filename,const  arc_P *arcH);
void freeAtrFile(atr_P *atrH);
void freeArcFile(arc_P  *arcH);
void freePgnFile(pgn_P  *pgnH);
void readArcFile(OGRDataSourceH datasource,const char *arcfile,const char *attfile);
void readAtrFile(OGRDataSourceH datasource,const char *atrfile,const char *arcfile);
void readPntFile( OGRDataSourceH datasource,const char *pngfile,const char *attfile);
void readPgnFile(OGRDataSourceH datasource,const char *pgnfile ,const char *arcfile,const char *attfile);
int createOGRLinstringObject(OGRDataSourceH datasource ,const arc_P * arcH,const atr_P * atrH);
int createOGRLinstringObjectFromAtr(OGRDataSourceH datasource ,const arc_P * arcH,const atr_P * atrH);
int createOGRPointObject( OGRDataSourceH datasource,const pnt_P * pntH,const atr_P * atrH);
int createOGRPolygonObject( OGRDataSourceH datasource,const pgn_P * pgnH,const atr_P * atrH);
OGRDataSourceH createDataSouce(OGRDataSourceH  ,const char *,const OGRSpatialReferenceH sRef);
void closeRoadDataresoutce( OGRDataSourceH  );


OGRDataSourceH  sdfDatasource[DATASOURCE_MAX];//HOGRf[^\[X
		

char *convertEncodingEUC(const char *str);
